10 REM PROGRAMMED IN DARTMOUTH BASIC BY MAC OGLESBY, OCT. 1975.
20 REM APPEARED IN PEOPLE'S COMPUTER CO NEWSPAPER, MAR/APR 1976.
30 REM DESCRIBED IN MARTIN GARDNER'S MATHEMATICAL GAMES COLUMN
40 REM IN SCIENTIFIC AMERICAN, JUNE 1975. ORIGINAL GAME CONCEPT
50 REM BY COLIN VOUT, 1972, WHILE A STUDENT AT UNIV OF CAMBRIDGE.
60 REM CONVERS. TO MS BASIC BY CREATIVE COMPUTING'S STEVE NORTH,'79
70 REM REMS ADDED, TWEAKED FOR KIM-1 BASIC BY DAVE HASSLER, 2023.
80 REM
83 REM TO LOAD THE PAPERTAPE FILE, PUT $8C IN $7A AND $5C IN $7B
85 REM AFTER LOADING IT AND BEFORE WARM-STARING BASIC.
90 REM
100 REM dhh: IN THE S.A. COLUMN, GARDNER OPINES THAT THE 8x8 GAME IS
110 REM "MOST ENJOYABLE", BUT FOR SOME REASON, MAC MADE THE GAME
120 REM MAX OUT AT 6x6.  TO CHANGE TO 8x8, CHANGE THE FOLLOWING
130 REM LINES TO:
135 REM
140 REM 200 DIM P(9,9),D$(9,9)
150 REM 290 PRINT "BOARD SIZE (3-8)";
160 REM 320 IF (8-A)*(A-3)>=0 THEN 340
170 REM 510 A$(1)="1234567"
180 REM 520 A$(2)="ABCDEFG"
185 REM 3240 PRINT "YOU CHOOSE THE BOARD SIZE BETWEEN 3 AND 8."
189 REM
190 POKE 10920,169: REM DEFEAT KB9 RETURN-ALONE BUG
200 DIM P(7,7),D$(7,7)
240 PRINT "DO YOU WANT INSTRUCTIONS FOR DODGEM";
250 INPUT A$
260 REM GOSUB2950 *** NOT NEEDED (dhh)
270 IF LEFT$(A$,1)<>"Y"THEN290
280 GOSUB3130
290 PRINT "BOARD SIZE (3-6)";
300 INPUT A
310 A=INT(A)
320 IF (6-A)*(A-3)>=0 THEN 340
330 GOTO 290
340 P(1,0)=A-1:P(2,0)=A-1

370 REM MATRIX P KEEPS TRACK OF PIECES
380 FOR J=1 TO A-1
390 P(1,J)=10*J+1
400 NEXT J

420 FOR J=1 TO A-1
430 P(2,J)=10*A+J+1
440 NEXT J

450 REM LEGAL MOVES FOR DIGITS, THEN LETTERS
460 F=1
470 M$(1)="NES"
480 M$(2)="NE W"
490 C$(1)="DIGITS"
500 C$(2)="LETTERS"
510 A$(1)="12345"
520 A$(2)="ABCDE"

550 REM SET UP BOARD
560 FOR J=1 TO A
570 IF J=A THEN630
580 D$(J,1)=CHR$(48+J)
590 FOR K=2 TO A
600 D$(J,K)="."
610 NEXT K
620 GOTO 670
630 D$(J,1)="."
640 FOR K=2 TO A
650 D$(J,K)=CHR$(63+K)
660 NEXT K
670 NEXT J

690 PRINT "HOW MANY PLAYERS (1 OR 2)";
700 INPUT B
710 IF B=2 THEN800
720 IF B=1 THEN740
730 GOTO690
740 PRINT "OK, THE COMPUTER WILL MOVE THE DIGITS."
750 PRINT "WHO MOVES FIRST (1=COMPUTER, 2=YOU)";
760 INPUT F
770 IF (2-F)*(1-F)=0 THEN800
780 PRINT "PLEASE TYPE 1 OR 2. NOW,";
790 GOTO750
800 PRINT
810 PRINT "HERE WE GO..."

830 REM PRINT DISPLAY
840 PRINT:PRINT:PRINT
850 FOR J=1 TO A
860 FOR K=1 TO A
870 PRINT "  ";D$(J,K);
880 NEXT K
890 PRINT
900 NEXT J
910 PRINT

940 REM MAIN MOVE LOOP
950 FOR J=F TO 3-F STEP 3-2*F

960 REM CHECK IF PLAYER J HAS A LEGAL MOVE LEFT
980 FOR J1=1 TO A-1
990 R=INT(P(J,J1)/10)
1000 C=P(J,J1)-10*R
1020 ON J GOTO1040,1100
1040 IF C=A THEN1080
1050 IF C>A THEN1070
1060 GOTO1160
1070 GOTO1250
1080 GOTO1300
1100 IF R=1 THEN1140
1110 IF R=0 THEN1130
1120 GOTO1160
1130 GOTO1250
1140 GOTO1300
1160 REM
1165 IF D$(R-1,C)="." THEN1240
1170 IF D$(R,C+1)="." THEN1240
1180 IF J=2 THEN 1220
1190 IF D$(R+1,C)="." THEN1210
1200 GOTO1250
1210 GOTO1300
1220 IF D$(R,C-1)="." THEN1240
1230 GOTO1250
1240 GOTO1300
1245 REM PRINT "BBS--1245",J1 ******* NOT IN OGLESBY'S SOURCE
1250 NEXT J1

1260 PRINT "THE ";C$(3-J);" HAVE NO LEGAL MOVES FOR THE ";C$(J);"!"
1270 PRINT "THE ";C$(J);" WIN!!!"
1280 GOTO3600

1300 IF B=2 THEN1750
1310 IF J=2 THEN1750

1330 REM GENERATE COMPUTER'S MOVE
1340 L1=2
1350 FOR L0=1 TO 3
1370 ON L0 GOTO1450,1380,1430
1380 IF RND(1)<.5 THEN1410
1390 L1=1
1400 GOTO1450
1410 L1=3
1420 GOTO1450
1430 L1=4-L1

1450 P1=INT(RND(1)*A)
1460 FOR L2=1 TO A-1
1470 P1=P1+1
1480 IF P1<=A-1 THEN1500
1490 P1=P1-(A-1)
1500 R=INT(P(J,P1)/10)
1510 C=P(J,P1)-10*R
1520 IF C > A THEN1720

1540 ON L1 GOTO1570,1620,1690

1560 REM NORTH
1570 IF D$(R-1,C)="." THEN1590
1580 GOTO 1720
1590 GOTO 2090

1610 REM EAST
1620 IF D$(R,C+1)="." THEN1660
1630 IF C=A THEN1650
1640 GOTO 1720
1650 P(J,0)=P(J,0)-1
1660 GOTO2160

1680 REM SOUTH
1690 IF D$(R+1,C)="." THEN1710
1700 GOTO1720
1710 GOTO2230
1720 NEXT L2
1730 NEXT L0
1740 GOTO1260: REM NOT IN MAC'S ORIGINAL PROGRAM; S.N. ADDITION?

1750 PRINT C$(J);" MOVE";
1760 INPUT A$
1770 GOSUB2950: REM PROCESS INPUT

1790 IF LEFT$(A$,1)="R" THEN2860
1800 IF LEFT$(A$,1)="H" THEN2460
1810 A$=MID$(A$,1,2)
1811 P1=0: REM *** EXTENSIVE REWORKING BY NORTH FOR MS BASIC 
1813 FOR B0=1 TO A-1
1815 IF MID$(A$(J),B0,1)=MID$(A$,1,1) THEN P1=B0
1817 NEXT B0

1830 IF P1=0 THEN2430
1832 P2=0
1834 FOR B0=1 TO 4
1836 IF MID$(M$(J),B0,1)=MID$(A$,2,1) THEN P2=B0
1838 NEXT B0
1850 IF P2=0 THEN2430
1860 R=INT(P(J,P1)/10)
1870 C=P(J,P1)-10*R
1880 IF R=0 THEN2430
1890 IF C>A THEN 430

1910 ON J GOTO1930,1990

1930 IF C<A THEN1970
1940 IF P2<>2 THEN1970
1950 P(1,0)=P(1,0)-1
1960 GOTO2160
1970 GOTO2040

1990 IF R>1 THEN2040
2000 IF P2<>1 THEN2040
2010 P(2,0)=P(2,0)-1
2020 GOTO2090

2040 ON P2 GOTO2070,2140,2210,2280

2060 REM CAN PIECE MOVE NORTH?
2070 IF D$(R-1,C)="." THEN2090
2080 GOTO2430
2090 D$(R-1,C)=MID$(A$(J),P1,1)
2100 P(J,P1)=P(J,P1)-10
2110 GOTO2330

2130 REM EAST?
2140 IF D$(R,C+1)="." THEN2160
2150 GOTO 2430
2160 D$(R,C+1) = MID$(A$(J),P1,1)
2170 P(J,P1)=P(J,P1)+1
2180 GOTO 2330

2200 REM SOUTH?
2210 IF D$(R+1,C)="." THEN 2230
2220 GOTO 2430
2230 D$(R+1,C)=MID$(A$(J) ,P1,1)
2240 P(J,P1)=P(J,P1)+10
2250 GOTO 2330

2270 REM WEST?
2280 IF D$(R,C-1)="." THEN 2300
2290 GOTO 2430
2300 D$(R,C-1)=MID$(A$(J),P1,1)
2310 P(J,P1)=P(J,P1)-1
2330 D$(R,C)="."
2340 IF B=2 THEN2380
2350 IF J=2 THEN2380
2360 PRINT "THE DIGITS MOVE: ";MID$(A$(J),P1,1);
2365 PRINT MID$(M$(J),L1,1)
2380 IF P(J,0) <> 0 THEN 2420
2390 PRINT
2400 PRINT "*** THE ";C$(J);" WIN!!!"
2410 GOTO3600
2420 GOTO2900
2430 PRINT "ILLEGAL MOVE OR BAD INPUT."
2440 PRINT "INPUT IGNORED. TYPE H FOR HELP."
2450 GOTO 1750
2460 PRINT "THE ";C$(J);" HAVE THESE LEGAL MOVES:"

2470 REM HELP! PRINT THE LEGAL MOVES
2480 FOR J3=1 TO A-1
2490 P$=MID$(A$(J),J3,1)
2500 R=INT(P(J,J3)/10)
2510 C=P(J,J3)-10*R
2530 ON J GOTO 2550,2620
2550 IF C=A THEN 2590

2560 IF C>A THEN 2580
2570 GOTO 2690
2580 GOTO 2830
2590 PRINT " ";P$;"E";
2600 GOTO 2690

2620 IF R=1 THEN 2660
2630 IF R=0 THEN 2650
2640 GOTO 2690
2650 GOTO 2830
2660 GOTO 2700

2680 REM NORTH
2690 IF D$(R-1,C)<>"." THEN 2730
2700 PRINT "  ";P$;"N";

2720 REM EAST
2730 IF D$(R,C+1)<>"." THEN 2770
2740 PRINT "  ";P$;"E";

2760 REM SOUTH AND WEST
2770 IF J=2 THEN 2810
2780 IF D$(R+1,C)<>"." THEN 2800
2790 PRINT "  ";P$;"S";
2800 GOTO 2830
2810 IF D$(R,C-1)<>"." THEN 2830
2820 PRINT "  ";P$;"W";
2830 NEXT J3
2840 PRINT
2850 GOTO 1750: REM TRY AGAIN
2860 PRINT "THE ";C$(J);" GIVE UP!!"
2870 PRINT "*** THE ";C$(3-J);" WIN!!!"
2880 GOTO3600

2900 NEXT J
2910 GOTO840: REM PRINT DISPLAY

2940 REM PROCESS INPUT LC/UC, IGNORE COMMA & SPC, REWORKED BY NORTH
2950 IF LEN(A$)>10 THEN 3090
2960 C1=0
2963 FOR B0=1 TO LEN(A$)
2965 A(B0)=ASC(MID$(A$,B0,1))
2970 NEXT B0
2975 A(0)=LEN(A$)
2980 FOR J2=1 TO A(0)

2990 REM IF A(J2)<96 THEN3010 *** l/c TO U/C NOT NEEDED (dhh)
3000 REM A(J2)=A(J2)-32

3010 IF (57-A(J2))*(A(J2)-48)>=0 THEN3040
3020 IF (90-A(J2))*(A(J2)-65)>=0 THEN3040
3030 GOTO 3060
3040 C1=C1+1
3050 A(C1)=A(J2)
3060 NEXT J2
3070 A(0)=C1
3073 A$=""
3075 FOR B0=1 TO A(0)
3077 A$=A$+CHR$(A(B0))
3080 NEXT B0
3090 RETURN

3120 REM INSTRUCTIONS
3130 PRINT
3140 PRINT "HERE'S A SAMPLE PLAYING BOARD:"
3150 PRINT
3160 PRINT "1 . . . ."
3170 PRINT "2 . . . ."
3180 PRINT "3 . . . ."
3190 PRINT "4 . . . ."
3200 PRINT ". A B C D"
3210 PRINT
3220 PRINT "TWO SETS OF PIECES (DIG AND LET) RACE AT RIGHT ANGLES"
3230 PRINT "ACROSS A SQUARE BOARD. VACANT LOCATIONS ARE PERIODS."
3240 PRINT "YOU GET TO CHOOSE THE BOARD SIZE BETWEEN 3 AND 6."
3245 PRINT "(SHOWN ABOVE IS SIZE 5)"
3250 PRINT

3252 INPUT"PRESS <RETURN> TO CONTINUE...";Z$ 
3255 PRINT
3260 PRINT "  N"
3280 PRINT "W-+-E"
3300 PRINT "  S"
3310 PRINT
3320 PRINT "THE OBJECT IS TO MOVE YOUR PIECES ACROSS THE BOARD"
3330 PRINT "AND OFF THE OPPOSITE EDGE. DIGITS LEAVE ONLY AT"
3340 PRINT "THE EASTERN EDGE; LETTERS AT THE NORTHERN. THE WINNER"
3350 PRINT "IS THE PLAYER WHOSE PIECES HAVE ALL LEFT THE BOARD."
3360 PRINT
3370 PRINT "THE PLAYERS GO IN TURN, MOVING ONE PIECE TO AN"
3380 PRINT "ADJACENT LOCATON WHICH IS EITHER OFF THE BOARD OR"
3390 PRINT "VACANT. THERE ARE NO DIAG MOVES, NO JUMPS, NO CAPTURES."
3400 PRINT "DIGITS CANNOT MOVE WEST, NOR LETTERS MOVE SOUTH."
3410 PRINT
3420 PRINT "TO MOVE A PIECE, TYPE ITS NAME AND THE LETTER OF THE"
3430 PRINT "DESIRED DIRECTION.  EXAMPLES:"
3440 PRINT "  2E = PIECE 2 GOES EAST   /   BW = PIECE B GOES WEST."
3450 PRINT
3452 INPUT"PRESS <RETURN> TO CONTINUE...";Z$
3460 PRINT
3470 PRINT "NOTE: YOU FORFEIT THE GAME IF YOUR MOVE LEAVES YOUR"
3480 PRINT "OPPONENT WITHOUT ANY LEGAL MOVE."
3490 PRINT
3500 PRINT "LASTLY, YOU MAY TYPE R TO RESIGN AND H FOR HELP."
3510 PRINT
3520 RETURN

3600 PRINT:INPUT"PLAY AGAIN (Y/N)";Z$
3610 IF LEFT$(Z$,1)<>"Y" THEN3630
3620 PRINT:GOTO290
3630 END