
1 REM Original Dartmouth BASIC program by Mac Oglesby, Feb. 1976, 
2 REM which appeared in the PCC Newspaper 7/76, vol 5, iss 1.

3 REM "Based on the game 'Three Musketeers' by Haar Hoolim,
4 REM described in Sid Sackson's book, 'A Gamut of Games'" --M.O. 

5 REM PET version expanded from the original, possibly by Oglesby,
6 REM and may have appeared in Calculators Computers Magazine
7 REM in the Feb. 1978 issue.

8 REM PET version adapted for KIM-1 BASIC and edited by
9 REM Dave Hassler, 2023, to play more like Oglesby's original. 

12 POKE10920,169:REM KILL RETURN-ALONE BUG

1000 REM***INITIALIZATION
1100 DIMD(6,6),P(12,6),M(4),R(4),C(4)
1105 DIMH(2,3),U(4)
1110 FORJ=1TO4:READM(J),R(J),C(J):NEXTJ
1120 DATA78,-1,0,69,0,1,83,1,0,87,0,-1
1130 FORJ=1TO5:FORK=1TO5:D(J,K)=64+(J-1)*5+K:NEXTK:NEXTJ
1140 FORI=1TO2:FORJ=1TO3
1150 H(I,J)=1+INT(5*RND(1))
1160 FORK=1TOJ-1
1170 IFK<JTHENIF H(I,J)=H(I,K)THEN1150
1180 NEXTK
1190 NEXTJ:NEXTI
1200 FORJ=1TO3:D(H(1,J),H(2,J))=666:NEXTJ

1220 FD$="#"
1230 PRINT:PRINT:PRINT
1240 PRINTTAB(10);"WELCOME TO . . . S I N N E R S"
1245 ?:?:?
1250 PRINTTAB(10);"WANT INSTRUCTIONS (YES OR NO)";:GOSUB6000
1260 IF LEFT$(B$,1)="Y" THEN GOSUB 9000

1490 ?:PRINT"(SETTING UP PERGATORY...)"


2000 REM***GENERATE COMPUTER'S MOVE
2100 MO=0
2110 FORJ=1TO5:FORK=1TO5
2120 IFD(J,K)<>666THEN2180
2130 FORL=1TO4
2140 IFD(J+R(L),K+C(L))<65ORD(J+R(L),K+C(L))>89THEN2170
2150 MO=MO+1:P(MO,1)=J:P(MO,2)=K
2160 P(MO,3)=J+R(L):P(MO,4)=K+C(L)
2170 NEXTL
2180 NEXTK:NEXTJ
2190 IFMO>0THEN2300
2200 GOSUB8000:PRINT"THE FIENDS CAN'T CAPTURE A SINNER:"
2205 PRINT"*ALL* REMAINING ARE CONDEMNED!"
2210 GOTO 9666

2300 SC=SC+1
2310 FORI=1TO3:FORJ=MOTO1STEP-1
2320 T9=1+INT(J*RND(1))
2325 TP=D(P(T9,3),P(T9,4))
2330 D(P(T9,1),P(T9,2))=32
2340 D(P(T9,3),P(T9,4))=666
2350 IFI<3THEN2400
2360 GOSUB8000
2370 PRINT"THE SINNERS WIN AND THE SURVIVORS ARE SET FREE!"
2380 END

2400 FORK=1TO5
2410 R9=0:C9=0
2420 FORL=1TO5
2430 IFD(K,L)=666THENR9=R9+1:IFR9>ITHEN2500
2440 IFD(L,K)=666THENC9=C9+1:IFC9>ITHEN2500
2450 NEXTL
2460 NEXTK:GOSUB8000:IFSC<22THEN3000
2470 PRINT"NO MORE SINNERS!":GOTO9666

2500 D(P(T9,1),P(T9,2))=666
2510 D(P(T9,3),P(T9,4))=TP
2520 IFT9=JTHEN2560
2530 FORJ0=1TO4:U(J0)=P(J,J0):NEXTJ0
2540 FORJ0=1TO4:P(J,J0)=P(T9,J0):NEXTJ0
2550 FORJ0=1TO4:P(T9,J0)=U(J0):NEXTJ0
2560 NEXTJ:NEXTI

3000 REM***PLAYER'S MOVE
3100 ?:PRINT"     SINNERS' MOVE";
3110 GOSUB6000

3200 IFB$="I"THENGOSUB9000:GOSUB8000:GOTO3100
3210 IFB$="H"THENGOSUB8000:GOSUB7000:GOTO3100
3220 IFB$="R"THENGOSUB8000:PRINT"THE SINNERS GIVE UP!":GOTO9666
3250 IFLEN(B$)<>2THEN3500
3260 SR=ASC(LEFT$(B$,1))

3300 FORJ=1TO5:FORK=1TO5
3310 IFD(J,K)=SRTHENR=J:C=K:GOTO3360
3320 NEXTK:NEXTJ
3330 GOTO3500
3360 DR=ASC(RIGHT$(B$,1))
3400 FORJ=1TO4
3410 IFDR<>M(J)THEN3450
3420 IFD(R+R(J),C+C(J))<>32THEN3500
3430 D(R+R(J),C+C(J))=D(R,C):D(R,C)=32:GOTO2000
3450 NEXTJ

3500 PRINT:PRINT"SOMETHING IS WRONG..."
3510 PRINT"   TYPE H FOR HELP."
3520 PRINT"   TYPE I FOR INSTRUCTIONS."
3530 PRINT"   TYPE R TO RESIGN THE GAME."
3540 GOTO3100

6000 REM***GET PLAYER'S INPUT
6010 INPUT B$
6020 RETURN

7000 REM***HELP ROUTINE
7100 PRINT"LEGAL MOVES:";
7110 FORJ=1TO5:FORK=1TO5
7120 IFD(J,K)<65ORD(J,K)>89THEN7160
7130 FORL=1TO4
7140 IFD(J+R(L),K+C(L))=32THENPRINT" ";CHR$(D(J,K));CHR$(M(L));
7150 NEXTL
7160 NEXTK:NEXTJ
7170 PRINT
7200 RETURN

8000 REM***PRINT THE BOARD ROUTINE
8002 PRINT:?:?:?
8005 PRINTTAB(5);"+-----------+"
8110 FORJ=1TO5:?"     ! ";
8120 FORK=1TO5
8125 IFD(J,K)<90THENLR$=CHR$((D(J,K))+32)
8130 IFD(J,K)=666THENPRINTFD$;
8140 IFD(J,K)>64AND D(J,K)<90THENPRINTLR$;
8150 IFD(J,K)=32THENPRINT" ";
8160 IFK<5THENPRINT".";
8170 NEXTK:?" !"
8190 NEXTJ:PRINTTAB(5);"+-----------+":RETURN

9000 REM***INSTRUCTIONS
9100 PRINT:?"THREE EVIL FIENDS (MOVED BY THE PAL-1)"
9110 PRINT"PLAY AGAINST A GROUP OF CONDEMNED"
9120 PRINT"SINNERS IN PERGATORY (MOVED BY YOU)."
9123 PRINT"IF THE SINNERS WIN, THE SURVIVORS WILL BE SET FREE."
9125 PRINT"OTHERWISE <SHUDDER>, IT'S INTO THE BLACK PIT!"
9130 PRINT
9140 PRINT"THE PLAYING FIELD HAS 25 SPACES. # = FIENDS,"
9150 PRINT"WHILE SINNERS ARE LETTERS."
9160 PRINT
9170 PRINT"A SINNER MAY MOVE INTO ANY ADJACENT EMPTY SPACE."
9180 PRINT"A FIEND MAY MOVE INTO AN ADJACENT SPACE THAT CONTAINS"
9190 PRINT"A SINNER, WHO IS THEREBY CAPTURED AND REMOVED"
9200 PRINT"TO ... WELL ... *YOU KNOW WHERE*."
9210 PRINT"THERE ARE NO DIAGONAL MOVES AND NO JUMPS."
9230 PRINT
9240 PRINT"THE SINNERS WIN IF ALL THE FIENDS ARE IN A LINE"
9250 PRINT"HORIZONTALLY OR VERTICALLY.  THE SINNERS LOSE IF THE"
9260 PRINT"FIENDS, AT THEIR TURN, CAN'T CAPTURE A SINNER."
9280 PRINT:PRINT:PRINT
9290 INPUT"PRESS <RETURN> TO CONTINUE";W$
9300 ?:?:?
9310 PRINT"  N"
9320 PRINT"W + E"
9330 PRINT"  S"
9340 PRINT
9350 PRINT"TO MOVE A SINNER, TYPE TWO LETTERS:"
9360 PRINT"THE FIRST LETTER NAMES THE SINNER
9370 PRINT"AND THE SECOND LETTER TELLS THE DIRECTION TO GO,"
9375 PRINT"THEN HIT <RETURN>.  FOR EXAMPLE:"
9390 PRINT"      JN MEANS SINNER J WILL TO MOVE UP."
9410 PRINT
9420 PRINT"ALSO, YOU CAN TYPE:"
9430 PRINT"  R WHEN YOU WANT TO RESIGN THE GAME"
9440 PRINT"  I FOR THESE INSTRUCTIONS"
9450 PRINT"  H FOR HELP WITH LEGAL MOVES"
9470 PRINT
9480 PRINT"HIT <RETURN> TO START THE GAME."

9500 INPUT Z$
9510 RETURN
9666 REM SINNERS GO TO HADES
9670 PRINT"*** THE SINNERS SINK DOWN D"
9680 PRINTTAB(27);"O":PRINTTAB(28);"W":PRINTTAB(29);"N...";
9690 PRINT"<SHUDDER>...INTO THE BLACK PIT!"
9695 PRINT"** ABANDON ALL HOPE! **"
9699 END
